/* IconView.c generated by valac 0.56.14, the Vala compiler
 * generated from IconView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2017 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <granite.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gtksourceview/gtksource.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_ICON_VIEW (icon_view_get_type ())
#define ICON_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ICON_VIEW, IconView))
#define ICON_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ICON_VIEW, IconViewClass))
#define IS_ICON_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ICON_VIEW))
#define IS_ICON_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ICON_VIEW))
#define ICON_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ICON_VIEW, IconViewClass))

typedef struct _IconView IconView;
typedef struct _IconViewClass IconViewClass;
typedef struct _IconViewPrivate IconViewPrivate;
enum  {
	ICON_VIEW_0_PROPERTY,
	ICON_VIEW_NUM_PROPERTIES
};
static GParamSpec* icon_view_properties[ICON_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _IconView {
	GraniteSimpleSettingsPage parent_instance;
	IconViewPrivate * priv;
};

struct _IconViewClass {
	GraniteSimpleSettingsPageClass parent_class;
};

struct _IconViewPrivate {
	GtkGrid* color_row;
	GtkGrid* symbolic_row;
};

struct _Block2Data {
	int _ref_count_;
	IconView* self;
	GtkSourceBuffer* source_buffer;
	GtkIconTheme* icon_theme;
	gint* pixels;
	gint pixels_length1;
	gint _pixels_size_;
};

static gint IconView_private_offset;
static gpointer icon_view_parent_class = NULL;

VALA_EXTERN GType icon_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IconView, g_object_unref)
VALA_EXTERN IconView* icon_view_new (void);
VALA_EXTERN IconView* icon_view_construct (GType object_type);
static GObject * icon_view_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void _icon_view___lambda4_ (Block2Data* _data2_);
static void __icon_view___lambda4__g_object_notify (GObject* _sender,
                                             GParamSpec* pspec,
                                             gpointer self);
static void icon_view_finalize (GObject * obj);
static GType icon_view_get_type_once (void);

static inline gpointer
icon_view_get_instance_private (IconView* self)
{
	return G_STRUCT_MEMBER_P (self, IconView_private_offset);
}

IconView*
icon_view_construct (GType object_type)
{
	IconView * self = NULL;
	self = (IconView*) g_object_new (object_type, "icon-name", "address-book-new", "description", _ ("Create a new address book"), NULL);
	return self;
}

IconView*
icon_view_new (void)
{
	return icon_view_construct (TYPE_ICON_VIEW);
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		IconView* self;
		self = _data2_->self;
		_data2_->pixels = (g_free (_data2_->pixels), NULL);
		_g_object_unref0 (_data2_->icon_theme);
		_g_object_unref0 (_data2_->source_buffer);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static void
_icon_view___lambda4_ (Block2Data* _data2_)
{
	IconView* self;
	gboolean is_symbolic = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* color_icon_name = NULL;
	gchar* symbolic_icon_name = NULL;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gboolean has_color = FALSE;
	GtkIconTheme* _tmp10_;
	const gchar* _tmp11_;
	gboolean _tmp12_ = FALSE;
	const gchar* _tmp14_;
	GtkSourceBuffer* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gint i = 0;
	gboolean has_symbolic = FALSE;
	GtkIconTheme* _tmp20_;
	const gchar* _tmp21_;
	GtkGrid* _tmp22_;
	GList* _tmp23_;
	GtkGrid* _tmp25_;
	GList* _tmp26_;
	gint* _tmp28_;
	gint _tmp28__length1;
	GtkLabel* not_has_label = NULL;
	GtkLabel* _tmp70_;
	GtkLabel* _tmp71_;
	GtkLabel* _tmp72_;
	GtkStyleContext* style_context = NULL;
	GtkLabel* _tmp73_;
	GtkStyleContext* _tmp74_;
	GtkStyleContext* _tmp75_;
	GtkStyleContext* _tmp76_;
	GtkStyleContext* _tmp77_;
	self = _data2_->self;
	_tmp0_ = granite_simple_settings_page_get_icon_name ((GraniteSimpleSettingsPage*) self);
	_tmp1_ = _tmp0_;
	is_symbolic = g_str_has_suffix (_tmp1_, "-symbolic");
	if (is_symbolic) {
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp2_ = granite_simple_settings_page_get_icon_name ((GraniteSimpleSettingsPage*) self);
		_tmp3_ = _tmp2_;
		_tmp4_ = string_replace (_tmp3_, "-symbolic", "");
		_g_free0 (color_icon_name);
		color_icon_name = _tmp4_;
	} else {
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		_tmp5_ = granite_simple_settings_page_get_icon_name ((GraniteSimpleSettingsPage*) self);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_strdup (_tmp6_);
		_g_free0 (color_icon_name);
		color_icon_name = _tmp7_;
	}
	_tmp8_ = color_icon_name;
	_tmp9_ = g_strconcat (_tmp8_, "-symbolic", NULL);
	symbolic_icon_name = _tmp9_;
	_tmp10_ = _data2_->icon_theme;
	_tmp11_ = color_icon_name;
	has_color = gtk_icon_theme_has_icon (_tmp10_, _tmp11_);
	if (!is_symbolic) {
		_tmp12_ = !has_color;
	} else {
		_tmp12_ = FALSE;
	}
	if (_tmp12_) {
		const gchar* _tmp13_;
		_tmp13_ = symbolic_icon_name;
		granite_simple_settings_page_set_icon_name ((GraniteSimpleSettingsPage*) self, _tmp13_);
	}
	_tmp14_ = color_icon_name;
	granite_simple_settings_page_set_title ((GraniteSimpleSettingsPage*) self, _tmp14_);
	_tmp15_ = _data2_->source_buffer;
	_tmp16_ = granite_simple_settings_page_get_icon_name ((GraniteSimpleSettingsPage*) self);
	_tmp17_ = _tmp16_;
	_tmp18_ = g_strdup_printf ("var icon = new Gtk.Image () {\n" \
"    gicon = new ThemedIcon (\"%s\"),\n" \
"    pixel_size = 24\n" \
"};", _tmp17_);
	_tmp19_ = _tmp18_;
	g_object_set ((GtkTextBuffer*) _tmp15_, "text", _tmp19_, NULL);
	_g_free0 (_tmp19_);
	i = 0;
	_tmp20_ = _data2_->icon_theme;
	_tmp21_ = symbolic_icon_name;
	has_symbolic = gtk_icon_theme_has_icon (_tmp20_, _tmp21_);
	_tmp22_ = self->priv->color_row;
	_tmp23_ = gtk_container_get_children ((GtkContainer*) _tmp22_);
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
		child_collection = _tmp23_;
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* child = NULL;
			child = (GtkWidget*) child_it->data;
			{
				GtkWidget* _tmp24_;
				_tmp24_ = child;
				gtk_widget_destroy (_tmp24_);
			}
		}
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
	}
	_tmp25_ = self->priv->symbolic_row;
	_tmp26_ = gtk_container_get_children ((GtkContainer*) _tmp25_);
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
		child_collection = _tmp26_;
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* child = NULL;
			child = (GtkWidget*) child_it->data;
			{
				GtkWidget* _tmp27_;
				_tmp27_ = child;
				gtk_widget_destroy (_tmp27_);
			}
		}
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
	}
	_tmp28_ = _data2_->pixels;
	_tmp28__length1 = _data2_->pixels_length1;
	{
		gint* pixel_size_collection = NULL;
		gint pixel_size_collection_length1 = 0;
		gint _pixel_size_collection_size_ = 0;
		gint pixel_size_it = 0;
		pixel_size_collection = _tmp28_;
		pixel_size_collection_length1 = _tmp28__length1;
		for (pixel_size_it = 0; pixel_size_it < pixel_size_collection_length1; pixel_size_it = pixel_size_it + 1) {
			gint pixel_size = 0;
			pixel_size = pixel_size_collection[pixel_size_it];
			{
				gint _tmp69_;
				if (has_color) {
					GtkImage* color_icon = NULL;
					GtkImage* _tmp29_;
					GtkImage* _tmp30_;
					const gchar* _tmp31_;
					GThemedIcon* _tmp32_;
					GThemedIcon* _tmp33_;
					GtkImage* _tmp34_;
					const gchar* _tmp35_;
					const gchar* _tmp36_;
					GtkImage* _tmp37_;
					GtkImage* _tmp38_;
					GtkImage* _tmp39_;
					GtkLabel* color_label = NULL;
					gint* _tmp40_;
					gint _tmp40__length1;
					gint _tmp41_;
					gchar* _tmp42_;
					gchar* _tmp43_;
					GtkLabel* _tmp44_;
					GtkLabel* _tmp45_;
					GtkLabel* _tmp46_;
					GtkGrid* _tmp47_;
					GtkImage* _tmp48_;
					GtkGrid* _tmp49_;
					GtkLabel* _tmp50_;
					_tmp29_ = (GtkImage*) gtk_image_new ();
					g_object_ref_sink (_tmp29_);
					color_icon = _tmp29_;
					_tmp30_ = color_icon;
					_tmp31_ = color_icon_name;
					_tmp32_ = (GThemedIcon*) g_themed_icon_new (_tmp31_);
					_tmp33_ = _tmp32_;
					g_object_set (_tmp30_, "gicon", (GIcon*) _tmp33_, NULL);
					_g_object_unref0 (_tmp33_);
					_tmp34_ = color_icon;
					_tmp35_ = granite_simple_settings_page_get_icon_name ((GraniteSimpleSettingsPage*) self);
					_tmp36_ = _tmp35_;
					g_object_set (_tmp34_, "icon-name", _tmp36_, NULL);
					_tmp37_ = color_icon;
					gtk_image_set_pixel_size (_tmp37_, pixel_size);
					_tmp38_ = color_icon;
					g_object_set (_tmp38_, "use-fallback", TRUE, NULL);
					_tmp39_ = color_icon;
					gtk_widget_set_valign ((GtkWidget*) _tmp39_, GTK_ALIGN_END);
					_tmp40_ = _data2_->pixels;
					_tmp40__length1 = _data2_->pixels_length1;
					_tmp41_ = _tmp40_[i];
					_tmp42_ = g_strdup_printf ("%ipx", _tmp41_);
					_tmp43_ = _tmp42_;
					_tmp44_ = (GtkLabel*) gtk_label_new (_tmp43_);
					g_object_ref_sink (_tmp44_);
					_tmp45_ = _tmp44_;
					_g_free0 (_tmp43_);
					color_label = _tmp45_;
					_tmp46_ = color_label;
					gtk_widget_set_hexpand ((GtkWidget*) _tmp46_, TRUE);
					_tmp47_ = self->priv->color_row;
					_tmp48_ = color_icon;
					gtk_grid_attach (_tmp47_, (GtkWidget*) _tmp48_, i, 0, 1, 1);
					_tmp49_ = self->priv->color_row;
					_tmp50_ = color_label;
					gtk_grid_attach (_tmp49_, (GtkWidget*) _tmp50_, i, 1, 1, 1);
					_g_object_unref0 (color_label);
					_g_object_unref0 (color_icon);
				}
				if (has_symbolic) {
					GtkImage* symbolic_icon = NULL;
					GtkImage* _tmp51_;
					GtkImage* _tmp52_;
					const gchar* _tmp53_;
					GThemedIcon* _tmp54_;
					GThemedIcon* _tmp55_;
					GtkImage* _tmp56_;
					GtkImage* _tmp57_;
					GtkLabel* symbolic_label = NULL;
					gint* _tmp58_;
					gint _tmp58__length1;
					gint _tmp59_;
					gchar* _tmp60_;
					gchar* _tmp61_;
					GtkLabel* _tmp62_;
					GtkLabel* _tmp63_;
					GtkLabel* _tmp64_;
					GtkGrid* _tmp65_;
					GtkImage* _tmp66_;
					GtkGrid* _tmp67_;
					GtkLabel* _tmp68_;
					_tmp51_ = (GtkImage*) gtk_image_new ();
					g_object_ref_sink (_tmp51_);
					symbolic_icon = _tmp51_;
					_tmp52_ = symbolic_icon;
					_tmp53_ = symbolic_icon_name;
					_tmp54_ = (GThemedIcon*) g_themed_icon_new (_tmp53_);
					_tmp55_ = _tmp54_;
					g_object_set (_tmp52_, "gicon", (GIcon*) _tmp55_, NULL);
					_g_object_unref0 (_tmp55_);
					_tmp56_ = symbolic_icon;
					gtk_image_set_pixel_size (_tmp56_, pixel_size);
					_tmp57_ = symbolic_icon;
					gtk_widget_set_valign ((GtkWidget*) _tmp57_, GTK_ALIGN_END);
					_tmp58_ = _data2_->pixels;
					_tmp58__length1 = _data2_->pixels_length1;
					_tmp59_ = _tmp58_[i];
					_tmp60_ = g_strdup_printf ("%ipx", _tmp59_);
					_tmp61_ = _tmp60_;
					_tmp62_ = (GtkLabel*) gtk_label_new (_tmp61_);
					g_object_ref_sink (_tmp62_);
					_tmp63_ = _tmp62_;
					_g_free0 (_tmp61_);
					symbolic_label = _tmp63_;
					_tmp64_ = symbolic_label;
					gtk_widget_set_hexpand ((GtkWidget*) _tmp64_, TRUE);
					_tmp65_ = self->priv->symbolic_row;
					_tmp66_ = symbolic_icon;
					gtk_grid_attach (_tmp65_, (GtkWidget*) _tmp66_, i, 0, 1, 1);
					_tmp67_ = self->priv->symbolic_row;
					_tmp68_ = symbolic_label;
					gtk_grid_attach (_tmp67_, (GtkWidget*) _tmp68_, i, 1, 1, 1);
					_g_object_unref0 (symbolic_label);
					_g_object_unref0 (symbolic_icon);
				}
				_tmp69_ = i;
				i = _tmp69_ + 1;
			}
		}
	}
	_tmp70_ = (GtkLabel*) gtk_label_new (_ ("Unavailable"));
	g_object_ref_sink (_tmp70_);
	not_has_label = _tmp70_;
	_tmp71_ = not_has_label;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp71_, TRUE);
	_tmp72_ = not_has_label;
	g_object_set ((GtkWidget*) _tmp72_, "height-request", 157, NULL);
	_tmp73_ = not_has_label;
	_tmp74_ = gtk_widget_get_style_context ((GtkWidget*) _tmp73_);
	_tmp75_ = _g_object_ref0 (_tmp74_);
	style_context = _tmp75_;
	_tmp76_ = style_context;
	gtk_style_context_add_class (_tmp76_, GTK_STYLE_CLASS_DIM_LABEL);
	_tmp77_ = style_context;
	gtk_style_context_add_class (_tmp77_, GRANITE_STYLE_CLASS_H3_LABEL);
	if (!has_color) {
		GtkGrid* _tmp78_;
		GtkLabel* _tmp79_;
		_tmp78_ = self->priv->color_row;
		_tmp79_ = not_has_label;
		gtk_container_add ((GtkContainer*) _tmp78_, (GtkWidget*) _tmp79_);
	} else {
		if (!has_symbolic) {
			GtkGrid* _tmp80_;
			GtkLabel* _tmp81_;
			_tmp80_ = self->priv->symbolic_row;
			_tmp81_ = not_has_label;
			gtk_container_add ((GtkContainer*) _tmp80_, (GtkWidget*) _tmp81_);
		}
	}
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (style_context);
	_g_object_unref0 (not_has_label);
	_g_free0 (symbolic_icon_name);
	_g_free0 (color_icon_name);
}

static void
__icon_view___lambda4__g_object_notify (GObject* _sender,
                                        GParamSpec* pspec,
                                        gpointer self)
{
	_icon_view___lambda4_ (self);
}

static GObject *
icon_view_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	IconView * self;
	Block2Data* _data2_;
	GtkLabel* color_title = NULL;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkGrid* _tmp5_;
	GtkGrid* _tmp6_;
	GtkGrid* _tmp7_;
	GtkLabel* symbolic_title = NULL;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkStyleContext* _tmp12_;
	GtkGrid* _tmp13_;
	GtkGrid* _tmp14_;
	GtkGrid* _tmp15_;
	GtkLabel* snippet_title = NULL;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* _tmp18_;
	GtkLabel* _tmp19_;
	GtkStyleContext* _tmp20_;
	GtkSourceBuffer* _tmp21_;
	GtkSourceBuffer* _tmp22_;
	GtkSourceBuffer* _tmp23_;
	GtkSourceLanguageManager* _tmp24_;
	GtkSourceLanguage* _tmp25_;
	GtkSourceBuffer* _tmp26_;
	GtkSourceStyleSchemeManager* _tmp27_;
	GtkSourceStyleSchemeManager* _tmp28_;
	GtkSourceStyleScheme* _tmp29_;
	GtkSourceView* source_view = NULL;
	GtkSourceView* _tmp30_;
	GtkSourceView* _tmp31_;
	GtkSourceBuffer* _tmp32_;
	GtkSourceView* _tmp33_;
	GtkSourceView* _tmp34_;
	GtkSourceView* _tmp35_;
	GtkSourceView* _tmp36_;
	GtkSourceView* _tmp37_;
	GtkSourceView* _tmp38_;
	GtkSourceView* _tmp39_;
	GtkGrid* snippet = NULL;
	GtkGrid* _tmp40_;
	GtkGrid* _tmp41_;
	GtkStyleContext* _tmp42_;
	GtkGrid* _tmp43_;
	GtkSourceView* _tmp44_;
	GtkGrid* _tmp45_;
	GtkGrid* _tmp46_;
	GtkGrid* _tmp47_;
	GtkGrid* _tmp48_;
	GtkGrid* _tmp49_;
	GtkGrid* _tmp50_;
	GtkGrid* _tmp51_;
	GtkGrid* _tmp52_;
	GtkLabel* _tmp53_;
	GtkGrid* _tmp54_;
	GtkGrid* _tmp55_;
	GtkGrid* _tmp56_;
	GtkGrid* _tmp57_;
	GtkGrid* _tmp58_;
	GtkLabel* _tmp59_;
	GtkGrid* _tmp60_;
	GtkGrid* _tmp61_;
	GtkGrid* _tmp62_;
	GtkGrid* _tmp63_;
	GtkGrid* _tmp64_;
	GtkLabel* _tmp65_;
	GtkGrid* _tmp66_;
	GtkGrid* _tmp67_;
	GtkGrid* _tmp68_;
	GtkIconTheme* _tmp69_;
	GtkIconTheme* _tmp70_;
	gint* _tmp71_;
	parent_class = G_OBJECT_CLASS (icon_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ICON_VIEW, IconView);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = (GtkLabel*) gtk_label_new (_ ("Color Icons"));
	g_object_ref_sink (_tmp0_);
	color_title = _tmp0_;
	_tmp1_ = color_title;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp1_, 12);
	_tmp2_ = color_title;
	gtk_label_set_xalign (_tmp2_, (gfloat) 0);
	_tmp3_ = color_title;
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) _tmp3_);
	gtk_style_context_add_class (_tmp4_, GRANITE_STYLE_CLASS_H4_LABEL);
	_tmp5_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->color_row);
	self->priv->color_row = _tmp5_;
	_tmp6_ = self->priv->color_row;
	gtk_grid_set_column_spacing (_tmp6_, 24);
	_tmp7_ = self->priv->color_row;
	gtk_grid_set_row_spacing (_tmp7_, 12);
	_tmp8_ = (GtkLabel*) gtk_label_new (_ ("Symbolic Icons"));
	g_object_ref_sink (_tmp8_);
	symbolic_title = _tmp8_;
	_tmp9_ = symbolic_title;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp9_, 12);
	_tmp10_ = symbolic_title;
	gtk_label_set_xalign (_tmp10_, (gfloat) 0);
	_tmp11_ = symbolic_title;
	_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) _tmp11_);
	gtk_style_context_add_class (_tmp12_, GRANITE_STYLE_CLASS_H4_LABEL);
	_tmp13_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp13_);
	_g_object_unref0 (self->priv->symbolic_row);
	self->priv->symbolic_row = _tmp13_;
	_tmp14_ = self->priv->symbolic_row;
	gtk_grid_set_column_spacing (_tmp14_, 24);
	_tmp15_ = self->priv->symbolic_row;
	gtk_grid_set_row_spacing (_tmp15_, 12);
	_tmp16_ = (GtkLabel*) gtk_label_new (_ ("Code Sample"));
	g_object_ref_sink (_tmp16_);
	snippet_title = _tmp16_;
	_tmp17_ = snippet_title;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp17_, 12);
	_tmp18_ = snippet_title;
	gtk_label_set_xalign (_tmp18_, (gfloat) 0);
	_tmp19_ = snippet_title;
	_tmp20_ = gtk_widget_get_style_context ((GtkWidget*) _tmp19_);
	gtk_style_context_add_class (_tmp20_, GRANITE_STYLE_CLASS_H4_LABEL);
	_tmp21_ = gtk_source_buffer_new (NULL);
	_data2_->source_buffer = _tmp21_;
	_tmp22_ = _data2_->source_buffer;
	gtk_source_buffer_set_highlight_syntax (_tmp22_, TRUE);
	_tmp23_ = _data2_->source_buffer;
	_tmp24_ = gtk_source_language_manager_get_default ();
	_tmp25_ = gtk_source_language_manager_get_language (_tmp24_, "vala");
	gtk_source_buffer_set_language (_tmp23_, _tmp25_);
	_tmp26_ = _data2_->source_buffer;
	_tmp27_ = gtk_source_style_scheme_manager_new ();
	_tmp28_ = _tmp27_;
	_tmp29_ = gtk_source_style_scheme_manager_get_scheme (_tmp28_, "solarized-light");
	gtk_source_buffer_set_style_scheme (_tmp26_, _tmp29_);
	_g_object_unref0 (_tmp28_);
	_tmp30_ = (GtkSourceView*) gtk_source_view_new ();
	g_object_ref_sink (_tmp30_);
	source_view = _tmp30_;
	_tmp31_ = source_view;
	_tmp32_ = _data2_->source_buffer;
	gtk_text_view_set_buffer ((GtkTextView*) _tmp31_, (GtkTextBuffer*) _tmp32_);
	_tmp33_ = source_view;
	gtk_text_view_set_editable ((GtkTextView*) _tmp33_, FALSE);
	_tmp34_ = source_view;
	_tmp35_ = source_view;
	gtk_text_view_set_right_margin ((GtkTextView*) _tmp35_, 6);
	gtk_text_view_set_left_margin ((GtkTextView*) _tmp34_, 6);
	_tmp36_ = source_view;
	gtk_text_view_set_monospace ((GtkTextView*) _tmp36_, TRUE);
	_tmp37_ = source_view;
	_tmp38_ = source_view;
	gtk_text_view_set_pixels_below_lines ((GtkTextView*) _tmp38_, 3);
	gtk_text_view_set_pixels_above_lines ((GtkTextView*) _tmp37_, 3);
	_tmp39_ = source_view;
	gtk_source_view_set_show_line_numbers (_tmp39_, TRUE);
	_tmp40_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp40_);
	snippet = _tmp40_;
	_tmp41_ = snippet;
	_tmp42_ = gtk_widget_get_style_context ((GtkWidget*) _tmp41_);
	gtk_style_context_add_class (_tmp42_, "code");
	_tmp43_ = snippet;
	_tmp44_ = source_view;
	gtk_container_add ((GtkContainer*) _tmp43_, (GtkWidget*) _tmp44_);
	_tmp45_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp46_ = _tmp45_;
	gtk_grid_set_column_spacing (_tmp46_, 12);
	_tmp47_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp48_ = _tmp47_;
	gtk_grid_set_row_spacing (_tmp48_, 12);
	_tmp49_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp50_ = _tmp49_;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp50_, GTK_ORIENTATION_VERTICAL);
	_tmp51_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp52_ = _tmp51_;
	_tmp53_ = color_title;
	gtk_container_add ((GtkContainer*) _tmp52_, (GtkWidget*) _tmp53_);
	_tmp54_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp55_ = _tmp54_;
	_tmp56_ = self->priv->color_row;
	gtk_container_add ((GtkContainer*) _tmp55_, (GtkWidget*) _tmp56_);
	_tmp57_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp58_ = _tmp57_;
	_tmp59_ = symbolic_title;
	gtk_container_add ((GtkContainer*) _tmp58_, (GtkWidget*) _tmp59_);
	_tmp60_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp61_ = _tmp60_;
	_tmp62_ = self->priv->symbolic_row;
	gtk_container_add ((GtkContainer*) _tmp61_, (GtkWidget*) _tmp62_);
	_tmp63_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp64_ = _tmp63_;
	_tmp65_ = snippet_title;
	gtk_container_add ((GtkContainer*) _tmp64_, (GtkWidget*) _tmp65_);
	_tmp66_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp67_ = _tmp66_;
	_tmp68_ = snippet;
	gtk_container_add ((GtkContainer*) _tmp67_, (GtkWidget*) _tmp68_);
	_tmp69_ = gtk_icon_theme_get_default ();
	_tmp70_ = _g_object_ref0 (_tmp69_);
	_data2_->icon_theme = _tmp70_;
	_tmp71_ = g_new0 (gint, 6);
	_tmp71_[0] = 16;
	_tmp71_[1] = 24;
	_tmp71_[2] = 32;
	_tmp71_[3] = 48;
	_tmp71_[4] = 64;
	_tmp71_[5] = 128;
	_data2_->pixels = _tmp71_;
	_data2_->pixels_length1 = 6;
	_data2_->_pixels_size_ = _data2_->pixels_length1;
	g_signal_connect_data ((GObject*) self, "notify::icon-name", (GCallback) __icon_view___lambda4__g_object_notify, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_g_object_unref0 (snippet);
	_g_object_unref0 (source_view);
	_g_object_unref0 (snippet_title);
	_g_object_unref0 (symbolic_title);
	_g_object_unref0 (color_title);
	block2_data_unref (_data2_);
	_data2_ = NULL;
	return obj;
}

static void
icon_view_class_init (IconViewClass * klass,
                      gpointer klass_data)
{
	icon_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &IconView_private_offset);
	G_OBJECT_CLASS (klass)->constructor = icon_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = icon_view_finalize;
}

static void
icon_view_instance_init (IconView * self,
                         gpointer klass)
{
	self->priv = icon_view_get_instance_private (self);
}

static void
icon_view_finalize (GObject * obj)
{
	IconView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ICON_VIEW, IconView);
	_g_object_unref0 (self->priv->color_row);
	_g_object_unref0 (self->priv->symbolic_row);
	G_OBJECT_CLASS (icon_view_parent_class)->finalize (obj);
}

static GType
icon_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (IconViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) icon_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IconView), 0, (GInstanceInitFunc) icon_view_instance_init, NULL };
	GType icon_view_type_id;
	icon_view_type_id = g_type_register_static (GRANITE_TYPE_SIMPLE_SETTINGS_PAGE, "IconView", &g_define_type_info, 0);
	IconView_private_offset = g_type_add_instance_private (icon_view_type_id, sizeof (IconViewPrivate));
	return icon_view_type_id;
}

GType
icon_view_get_type (void)
{
	static volatile gsize icon_view_type_id__once = 0;
	if (g_once_init_enter (&icon_view_type_id__once)) {
		GType icon_view_type_id;
		icon_view_type_id = icon_view_get_type_once ();
		g_once_init_leave (&icon_view_type_id__once, icon_view_type_id);
	}
	return icon_view_type_id__once;
}

