/* IconListRow.c generated by valac 0.56.14, the Vala compiler
 * generated from IconListRow.vala, do not modify */

/*
* Copyright (c) 2017 Daniel Foré (http://danielfore.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <pango/pango.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_ICON_LIST_ROW (icon_list_row_get_type ())
#define ICON_LIST_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ICON_LIST_ROW, IconListRow))
#define ICON_LIST_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ICON_LIST_ROW, IconListRowClass))
#define IS_ICON_LIST_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ICON_LIST_ROW))
#define IS_ICON_LIST_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ICON_LIST_ROW))
#define ICON_LIST_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ICON_LIST_ROW, IconListRowClass))

typedef struct _IconListRow IconListRow;
typedef struct _IconListRowClass IconListRowClass;
typedef struct _IconListRowPrivate IconListRowPrivate;
typedef enum  {
	CATEGORY_VIEW_CATEGORY_ACTIONS,
	CATEGORY_VIEW_CATEGORY_APPS,
	CATEGORY_VIEW_CATEGORY_CATEGORIES,
	CATEGORY_VIEW_CATEGORY_DEVICES,
	CATEGORY_VIEW_CATEGORY_EMBLEMS,
	CATEGORY_VIEW_CATEGORY_EMOTES,
	CATEGORY_VIEW_CATEGORY_MIMES,
	CATEGORY_VIEW_CATEGORY_PLACES,
	CATEGORY_VIEW_CATEGORY_STATUS
} CategoryViewCategory;

#define CATEGORY_VIEW_TYPE_CATEGORY (category_view_category_get_type ())
enum  {
	ICON_LIST_ROW_0_PROPERTY,
	ICON_LIST_ROW_CATEGORY_PROPERTY,
	ICON_LIST_ROW_DESCRIPTION_PROPERTY,
	ICON_LIST_ROW_ICON_NAME_PROPERTY,
	ICON_LIST_ROW_NUM_PROPERTIES
};
static GParamSpec* icon_list_row_properties[ICON_LIST_ROW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _IconListRow {
	GtkListBoxRow parent_instance;
	IconListRowPrivate * priv;
};

struct _IconListRowClass {
	GtkListBoxRowClass parent_class;
};

struct _IconListRowPrivate {
	CategoryViewCategory _category;
	gchar* _description;
	gchar* _icon_name;
};

static gint IconListRow_private_offset;
static gpointer icon_list_row_parent_class = NULL;

VALA_EXTERN GType icon_list_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IconListRow, g_object_unref)
VALA_EXTERN GType category_view_category_get_type (void) G_GNUC_CONST ;
VALA_EXTERN IconListRow* icon_list_row_new (const gchar* icon_name,
                                const gchar* description,
                                CategoryViewCategory category);
VALA_EXTERN IconListRow* icon_list_row_construct (GType object_type,
                                      const gchar* icon_name,
                                      const gchar* description,
                                      CategoryViewCategory category);
VALA_EXTERN CategoryViewCategory icon_list_row_get_category (IconListRow* self);
static void icon_list_row_set_category (IconListRow* self,
                                 CategoryViewCategory value);
VALA_EXTERN const gchar* icon_list_row_get_description (IconListRow* self);
static void icon_list_row_set_description (IconListRow* self,
                                    const gchar* value);
VALA_EXTERN const gchar* icon_list_row_get_icon_name (IconListRow* self);
static void icon_list_row_set_icon_name (IconListRow* self,
                                  const gchar* value);
static GObject * icon_list_row_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void icon_list_row_finalize (GObject * obj);
static GType icon_list_row_get_type_once (void);
static void _vala_icon_list_row_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_icon_list_row_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);

static inline gpointer
icon_list_row_get_instance_private (IconListRow* self)
{
	return G_STRUCT_MEMBER_P (self, IconListRow_private_offset);
}

IconListRow*
icon_list_row_construct (GType object_type,
                         const gchar* icon_name,
                         const gchar* description,
                         CategoryViewCategory category)
{
	IconListRow * self = NULL;
	g_return_val_if_fail (icon_name != NULL, NULL);
	g_return_val_if_fail (description != NULL, NULL);
	self = (IconListRow*) g_object_new (object_type, "category", category, "description", description, "icon-name", icon_name, NULL);
	return self;
}

IconListRow*
icon_list_row_new (const gchar* icon_name,
                   const gchar* description,
                   CategoryViewCategory category)
{
	return icon_list_row_construct (TYPE_ICON_LIST_ROW, icon_name, description, category);
}

CategoryViewCategory
icon_list_row_get_category (IconListRow* self)
{
	CategoryViewCategory result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_category;
	return result;
}

static void
icon_list_row_set_category (IconListRow* self,
                            CategoryViewCategory value)
{
	CategoryViewCategory old_value;
	g_return_if_fail (self != NULL);
	old_value = icon_list_row_get_category (self);
	if (old_value != value) {
		self->priv->_category = value;
		g_object_notify_by_pspec ((GObject *) self, icon_list_row_properties[ICON_LIST_ROW_CATEGORY_PROPERTY]);
	}
}

const gchar*
icon_list_row_get_description (IconListRow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_description;
	result = _tmp0_;
	return result;
}

static void
icon_list_row_set_description (IconListRow* self,
                               const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = icon_list_row_get_description (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_description);
		self->priv->_description = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, icon_list_row_properties[ICON_LIST_ROW_DESCRIPTION_PROPERTY]);
	}
}

const gchar*
icon_list_row_get_icon_name (IconListRow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_icon_name;
	result = _tmp0_;
	return result;
}

static void
icon_list_row_set_icon_name (IconListRow* self,
                             const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = icon_list_row_get_icon_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_icon_name);
		self->priv->_icon_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, icon_list_row_properties[ICON_LIST_ROW_ICON_NAME_PROPERTY]);
	}
}

static GObject *
icon_list_row_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	IconListRow * self;
	GtkImage* icon = NULL;
	GtkImage* _tmp0_;
	GtkIconTheme* _tmp1_;
	const gchar* _tmp2_;
	GtkLabel* label = NULL;
	const gchar* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp15_;
	GtkGrid* _tmp16_;
	GtkGrid* _tmp17_;
	GtkGrid* _tmp18_;
	GtkGrid* _tmp19_;
	GtkGrid* _tmp20_;
	GtkImage* _tmp21_;
	GtkGrid* _tmp22_;
	GtkLabel* _tmp23_;
	GtkGrid* _tmp24_;
	parent_class = G_OBJECT_CLASS (icon_list_row_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ICON_LIST_ROW, IconListRow);
	_tmp0_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp0_);
	icon = _tmp0_;
	_tmp1_ = gtk_icon_theme_get_default ();
	_tmp2_ = self->priv->_icon_name;
	if (gtk_icon_theme_has_icon (_tmp1_, _tmp2_)) {
		GtkImage* _tmp3_;
		const gchar* _tmp4_;
		GtkImage* _tmp5_;
		_tmp3_ = icon;
		_tmp4_ = self->priv->_icon_name;
		g_object_set (_tmp3_, "icon-name", _tmp4_, NULL);
		_tmp5_ = icon;
		gtk_image_set_pixel_size (_tmp5_, 24);
	} else {
		GtkImage* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GtkImage* _tmp10_;
		GtkImage* _tmp11_;
		_tmp6_ = icon;
		_tmp7_ = self->priv->_icon_name;
		_tmp8_ = g_strconcat (_tmp7_, "-symbolic", NULL);
		_tmp9_ = _tmp8_;
		g_object_set (_tmp6_, "icon-name", _tmp9_, NULL);
		_g_free0 (_tmp9_);
		_tmp10_ = icon;
		gtk_image_set_pixel_size (_tmp10_, 16);
		_tmp11_ = icon;
		gtk_widget_set_size_request ((GtkWidget*) _tmp11_, 24, 24);
	}
	_tmp12_ = self->priv->_icon_name;
	_tmp13_ = (GtkLabel*) gtk_label_new (_tmp12_);
	g_object_ref_sink (_tmp13_);
	label = _tmp13_;
	_tmp14_ = label;
	gtk_label_set_ellipsize (_tmp14_, PANGO_ELLIPSIZE_MIDDLE);
	_tmp15_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp15_);
	grid = _tmp15_;
	_tmp16_ = grid;
	gtk_grid_set_column_spacing (_tmp16_, 12);
	_tmp17_ = grid;
	g_object_set ((GtkWidget*) _tmp17_, "margin", 3, NULL);
	_tmp18_ = grid;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp18_, 6);
	_tmp19_ = grid;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp19_, 6);
	_tmp20_ = grid;
	_tmp21_ = icon;
	gtk_container_add ((GtkContainer*) _tmp20_, (GtkWidget*) _tmp21_);
	_tmp22_ = grid;
	_tmp23_ = label;
	gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp23_);
	_tmp24_ = grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp24_);
	_g_object_unref0 (grid);
	_g_object_unref0 (label);
	_g_object_unref0 (icon);
	return obj;
}

static void
icon_list_row_class_init (IconListRowClass * klass,
                          gpointer klass_data)
{
	icon_list_row_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &IconListRow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_icon_list_row_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_icon_list_row_set_property;
	G_OBJECT_CLASS (klass)->constructor = icon_list_row_constructor;
	G_OBJECT_CLASS (klass)->finalize = icon_list_row_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_LIST_ROW_CATEGORY_PROPERTY, icon_list_row_properties[ICON_LIST_ROW_CATEGORY_PROPERTY] = g_param_spec_enum ("category", "category", "category", CATEGORY_VIEW_TYPE_CATEGORY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_LIST_ROW_DESCRIPTION_PROPERTY, icon_list_row_properties[ICON_LIST_ROW_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ICON_LIST_ROW_ICON_NAME_PROPERTY, icon_list_row_properties[ICON_LIST_ROW_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
icon_list_row_instance_init (IconListRow * self,
                             gpointer klass)
{
	self->priv = icon_list_row_get_instance_private (self);
}

static void
icon_list_row_finalize (GObject * obj)
{
	IconListRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ICON_LIST_ROW, IconListRow);
	_g_free0 (self->priv->_description);
	_g_free0 (self->priv->_icon_name);
	G_OBJECT_CLASS (icon_list_row_parent_class)->finalize (obj);
}

static GType
icon_list_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (IconListRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) icon_list_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IconListRow), 0, (GInstanceInitFunc) icon_list_row_instance_init, NULL };
	GType icon_list_row_type_id;
	icon_list_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "IconListRow", &g_define_type_info, 0);
	IconListRow_private_offset = g_type_add_instance_private (icon_list_row_type_id, sizeof (IconListRowPrivate));
	return icon_list_row_type_id;
}

GType
icon_list_row_get_type (void)
{
	static volatile gsize icon_list_row_type_id__once = 0;
	if (g_once_init_enter (&icon_list_row_type_id__once)) {
		GType icon_list_row_type_id;
		icon_list_row_type_id = icon_list_row_get_type_once ();
		g_once_init_leave (&icon_list_row_type_id__once, icon_list_row_type_id);
	}
	return icon_list_row_type_id__once;
}

static void
_vala_icon_list_row_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	IconListRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ICON_LIST_ROW, IconListRow);
	switch (property_id) {
		case ICON_LIST_ROW_CATEGORY_PROPERTY:
		g_value_set_enum (value, icon_list_row_get_category (self));
		break;
		case ICON_LIST_ROW_DESCRIPTION_PROPERTY:
		g_value_set_string (value, icon_list_row_get_description (self));
		break;
		case ICON_LIST_ROW_ICON_NAME_PROPERTY:
		g_value_set_string (value, icon_list_row_get_icon_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_icon_list_row_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	IconListRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ICON_LIST_ROW, IconListRow);
	switch (property_id) {
		case ICON_LIST_ROW_CATEGORY_PROPERTY:
		icon_list_row_set_category (self, g_value_get_enum (value));
		break;
		case ICON_LIST_ROW_DESCRIPTION_PROPERTY:
		icon_list_row_set_description (self, g_value_get_string (value));
		break;
		case ICON_LIST_ROW_ICON_NAME_PROPERTY:
		icon_list_row_set_icon_name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

